C*****************************************************
c terme proportionnel a 1/(1-z)_+ dans les noyaux d'altarelli-parisi
c p_ij^4(z) = a_ij^4(z)/(1-z)_+ + b_ij \delta(1-z)
	DOUBLE PRECISION FUNCTION A4_QQ(Z)
	IMPLICIT REAL*8 (A-H,L-Z)
	COMMON/COUL/N,CF,GTR
	A4_QQ = CF*(1.D0+Z**2)
	RETURN
	END
C--------------------------------------------------------------
	DOUBLE PRECISION FUNCTION A4_GG(Z)
	IMPLICIT REAL*8 (A-H,L-Z)
	COMMON/COUL/N,CF,GTR
	A4_GG = 2.D0*N*(Z+(1.D0-Z)**2/Z+Z*(1.D0-Z)**2)
	RETURN
	END
C--------------------------------------------------------------
	DOUBLE PRECISION FUNCTION A4_QG(Z)
	IMPLICIT REAL*8 (A-H,L-Z)
	COMMON/COUL/N,CF,GTR
	TF = .5D0
	A4_QG = TF*(Z**2+(1.D0-Z)**2)*(1.D0-Z)
	RETURN
	END
C--------------------------------------------------------------
	DOUBLE PRECISION FUNCTION A4_GQ(Z)
	IMPLICIT REAL*8 (A-H,L-Z)
	COMMON/COUL/N,CF,GTR
	A4_GQ = CF*(1.D0+(1.D0-Z)**2)/Z*(1.D0-Z)
	RETURN
	END
C--------------------------------------------------------------
	DOUBLE PRECISION FUNCTION A4_QP(Z)
	IMPLICIT REAL*8 (A-H,L-Z)
	COMMON/COUL/N,CF,GTR
	A4_QP = N*(Z**2+(1.D0-Z)**2)*(1.D0-Z)
	RETURN
	END
C--------------------------------------------------------------
	DOUBLE PRECISION FUNCTION A4_PQ(Z)
	IMPLICIT REAL*8 (A-H,L-Z)
	A4_PQ = (1.D0+(1.D0-Z)**2)/Z*(1.D0-Z)
	RETURN
	END
C*****************************************************
c terme proportionnel a \delta(1-z) dans les noyaux d'altarelli-parisi
c p_ij^4(z) = a_ij^4(z)/(1-z)_+ + b_ij \delta(1-z)
	DOUBLE PRECISION FUNCTION B_QQ()
	IMPLICIT REAL*8 (A-H,L-Z)
	COMMON/COUL/N,CF,GTR
	B_QQ = 3.D0/2.D0*CF
	RETURN
	END
C--------------------------------------------------------------
	DOUBLE PRECISION FUNCTION B_GG()
	IMPLICIT REAL*8 (A-H,L-Z)
	COMMON/COUL/N,CF,GTR
	B_GG = (11.D0*N-4.D0*GTR)/6.D0
	RETURN
	END
C*****************************************************
c extra terme venant des dimensions n-4
c a_ij^n(z) = a_ij^4(z) - epsilon a_ij^(n-4)(z)  , n = 4-2*epsilon
	DOUBLE PRECISION FUNCTION ANM4_QQ(Z)
	IMPLICIT REAL*8 (A-H,L-Z)
	COMMON/COUL/N,CF,GTR
	ANM4_QQ = CF*(1.D0-Z)**2
	RETURN
	END
C--------------------------------------------------------------
	DOUBLE PRECISION FUNCTION ANM4_GG(Z)
	IMPLICIT REAL*8 (A-H,L-Z)
	COMMON/COUL/N,CF,GTR
	ANM4_GG = 0.D0
	RETURN
	END
C--------------------------------------------------------------
	DOUBLE PRECISION FUNCTION ANM4_QG(Z)
	IMPLICIT REAL*8 (A-H,L-Z)
	COMMON/COUL/N,CF,GTR
	TF = .5D0
	ANM4_QG = TF*2.D0*Z*(1.D0-Z)**2
	RETURN
	END
C--------------------------------------------------------------
	DOUBLE PRECISION FUNCTION ANM4_GQ(Z)
	IMPLICIT REAL*8 (A-H,L-Z)
	COMMON/COUL/N,CF,GTR
	ANM4_GQ = CF*Z*(1.D0-Z)
	RETURN
	END
C--------------------------------------------------------------
	DOUBLE PRECISION FUNCTION ANM4_QP(Z)
	IMPLICIT REAL*8 (A-H,L-Z)
	COMMON/COUL/N,CF,GTR
	ANM4_QP = N*2.D0*Z*(1.D0-Z)**2
	RETURN
	END
C--------------------------------------------------------------
	DOUBLE PRECISION FUNCTION ANM4_PQ(Z)
	IMPLICIT REAL*8 (A-H,L-Z)
	ANM4_PQ = Z*(1.D0-Z)
	RETURN
	END
C
C*****************************************************
C elements de matrice 2 --> 2
C ces elements de matrice ne sont pas moyennes sur les
C spin et couleurs initiaux
C******************************************************
C see born_one_jet.f, born_dir_jet.f
C
C******************************************************
C facteur de couleur pour les differents elements de matrice 2 --> 2
C******************************************************
C see spcou_one_jet.f, spcou_dir_jet.f
C
C******************************************************	
C element de matrice 2 --> 2 a la Ellis et Sexton
C******************************************************
	DOUBLE PRECISION FUNCTION A(S,T,U,N)
	IMPLICIT REAL*8 (A-H,L-Z)
	VC = N*N - 1.D0
	A = 2.D0*VC*(S**2+U**2)/T**2
	RETURN
	END	
C
	DOUBLE PRECISION FUNCTION B(S,T,U,N)
	IMPLICIT REAL*8 (A-H,L-Z)
	VC = N*N - 1.D0
	B = -4.D0*VC/N*S**2/(U*T)
	RETURN
	END	
C
	DOUBLE PRECISION FUNCTION C(S,T,U,N)
	IMPLICIT REAL*8 (A-H,L-Z)
	VC = N*N - 1.D0
	C = 2.D0*VC/N*(VC/(U*T)-2.D0*N**2/S**2)*(T**2+U**2)
	RETURN
	END	
C
	DOUBLE PRECISION FUNCTION Dg(S,T,U,N)
	IMPLICIT REAL*8 (A-H,L-Z)
	VC = N*N - 1.D0
	Dg = 16.D0*VC*N**2*(3.D0-U*T/S**2-U*S/T**2-S*T/U**2)
	RETURN
	END	
C
	DOUBLE PRECISION FUNCTION E(S,T,U,N)
	IMPLICIT REAL*8 (A-H,L-Z)
	VC = N*N - 1.D0
	E = 4.D0*VC/(U*T)*(T**2+U**2)
	RETURN
	END	
C
	DOUBLE PRECISION FUNCTION F(S,T,U,N)
	IMPLICIT REAL*8 (A-H,L-Z)
	F = 8.D0*N/(U*T)*(T**2+U**2)
	RETURN
	END	
C*****************************************************
C reaction gluon + gluon --> photon + photon
C moved to src/dir_phot_jet.f
C*****************************************************
	DOUBLE PRECISION FUNCTION FAQQ(Z)
	IMPLICIT REAL*8 (A-H,L-Z)
	COMMON/FSCHEME/ISCHEME
	COMMON/COUL/N,CF,GTR
	IF (ISCHEME.EQ.0) THEN
	  FAQQ = 0.D0
	ELSE IF (ISCHEME.EQ.1) THEN
	  FAQQ = CF*(-3.D0/2.D0-(1.D0+Z**2)*DLOG(Z)+(3.D0+2.D0*Z)*
     #	         (1.D0-Z))
	ENDIF 
	RETURN
	END
	DOUBLE PRECISION FUNCTION FBQQ(Z)
	IMPLICIT REAL*8 (A-H,L-Z)
	COMMON/FSCHEME/ISCHEME
	COMMON/COUL/N,CF,GTR
	IF (ISCHEME.EQ.0) THEN
	  FBQQ = 0.D0
	ELSE IF (ISCHEME.EQ.1) THEN
	  FBQQ = CF*(1.D0+Z**2)
	ENDIF 
	RETURN
	END
	DOUBLE PRECISION FUNCTION FCQQ(Z)
	IMPLICIT REAL*8 (A-H,L-Z)
	COMMON/FSCHEME/ISCHEME
	COMMON/COUL/N,CF,GTR
	PI=DATAN(1.D0)*4.D0
	IF (ISCHEME.EQ.0) THEN
	  FCQQ = 0.D0
	ELSE IF (ISCHEME.EQ.1) THEN
	  FCQQ = -CF*(9.D0/2.D0+PI**2/3.D0)
	ENDIF 
	RETURN
	END
	DOUBLE PRECISION FUNCTION FAQG(Z)
	IMPLICIT REAL*8 (A-H,L-Z)
	COMMON/FSCHEME/ISCHEME
	COMMON/AURENCHE/IAUREN
	IF (ISCHEME.EQ.0) THEN
	  FAQG = 0.D0
	ELSE IF (ISCHEME.EQ.1) THEN
c convention 2*(1-epsilon) degrees de polaristion pour le gluon
	  IF (IAUREN.EQ.0) THEN
	    FAQG = 1.D0/2.D0*(-(Z**2+(1.D0-Z)**2)*DLOG(Z)
     #	           )*(1.D0-Z)
c convention 2 degrees de polaristion pour le gluon
	  ELSE IF (IAUREN.EQ.1) THEN
	    FAQG = 1.D0/2.D0*(-(Z**2+(1.D0-Z)**2)*DLOG(Z)
     #	           +6.D0*Z*(1.D0-Z))*(1.D0-Z)
	  ENDIF 
	ENDIF 
	RETURN
	END
	DOUBLE PRECISION FUNCTION FBQG(Z)
	IMPLICIT REAL*8 (A-H,L-Z)
	COMMON/FSCHEME/ISCHEME
	IF (ISCHEME.EQ.0) THEN
	  FBQG=0.D0
	ELSE IF (ISCHEME.EQ.1) THEN
	  FBQG = 1.D0/2.D0*(Z**2+(1.D0-Z)**2)
     #	         *(1.D0-Z)
	ENDIF 
	RETURN
	END
	DOUBLE PRECISION FUNCTION FCQG(Z)
	IMPLICIT REAL*8 (A-H,L-Z)
	COMMON/FSCHEME/ISCHEME
	IF (ISCHEME.EQ.0) THEN
	  FCQG=0.D0
	ELSE IF (ISCHEME.EQ.1) THEN
	  FCQG=0.D0
	ENDIF 
	RETURN
	END
	DOUBLE PRECISION FUNCTION FAGQ(Z)
	IMPLICIT REAL*8 (A-H,L-Z)
	FAGQ=0.D0
	RETURN
	END
	DOUBLE PRECISION FUNCTION FBGQ(Z)
	IMPLICIT REAL*8 (A-H,L-Z)
	FBGQ=0.D0
	RETURN
	END
	DOUBLE PRECISION FUNCTION FCGQ(Z)
	IMPLICIT REAL*8 (A-H,L-Z)
	FCGQ=0.D0
	RETURN
	END
	DOUBLE PRECISION FUNCTION FAGG(Z)
	IMPLICIT REAL*8 (A-H,L-Z)
	FAGG=0.D0
	RETURN
	END
	DOUBLE PRECISION FUNCTION FBGG(Z)
	IMPLICIT REAL*8 (A-H,L-Z)
	FBGG=0.D0
	RETURN
	END
	DOUBLE PRECISION FUNCTION FCGG(Z)
	IMPLICIT REAL*8 (A-H,L-Z)
	FCGG=0.D0
	RETURN
	END
	DOUBLE PRECISION FUNCTION FAQP(Z)
	IMPLICIT REAL*8 (A-H,L-Z)
	FAQP=0.D0
	RETURN
	END
	DOUBLE PRECISION FUNCTION FBQP(Z)
	IMPLICIT REAL*8 (A-H,L-Z)
	FBQP=0.D0
	RETURN
	END
	DOUBLE PRECISION FUNCTION FCQP(Z)
	IMPLICIT REAL*8 (A-H,L-Z)
	FCQP=0.D0
	RETURN
	END
	DOUBLE PRECISION FUNCTION FAPQ(Z)
	IMPLICIT REAL*8 (A-H,L-Z)
	FAPQ=0.D0
	RETURN
	END
	DOUBLE PRECISION FUNCTION FBPQ(Z)
	IMPLICIT REAL*8 (A-H,L-Z)
	FBPQ=0.D0
	RETURN
	END
	DOUBLE PRECISION FUNCTION FCPQ(Z)
	IMPLICIT REAL*8 (A-H,L-Z)
	FCPQ=0.D0
	RETURN
	END
C*****************************************************
	DOUBLE PRECISION FUNCTION DAQQ(Z)
	IMPLICIT REAL*8 (A-H,L-Z)
	DAQQ=0.D0
	RETURN
	END
	DOUBLE PRECISION FUNCTION DBQQ(Z)
	IMPLICIT REAL*8 (A-H,L-Z)
	DBQQ=0.D0
	RETURN
	END
	DOUBLE PRECISION FUNCTION DCQQ(Z)
	IMPLICIT REAL*8 (A-H,L-Z)
	DCQQ=0.D0
	RETURN
	END
	DOUBLE PRECISION FUNCTION DAQG(Z)
	IMPLICIT REAL*8 (A-H,L-Z)
	DAQG=0.D0
	RETURN
	END
	DOUBLE PRECISION FUNCTION DBQG(Z)
	IMPLICIT REAL*8 (A-H,L-Z)
	DBQG=0.D0
	RETURN
	END
	DOUBLE PRECISION FUNCTION DCQG(Z)
	IMPLICIT REAL*8 (A-H,L-Z)
	DCQG=0.D0
	RETURN
	END
	DOUBLE PRECISION FUNCTION DAGQ(Z)
	IMPLICIT REAL*8 (A-H,L-Z)
	DAGQ=0.D0
	RETURN
	END
	DOUBLE PRECISION FUNCTION DBGQ(Z)
	IMPLICIT REAL*8 (A-H,L-Z)
	DBGQ=0.D0
	RETURN
	END
	DOUBLE PRECISION FUNCTION DCGQ(Z)
	IMPLICIT REAL*8 (A-H,L-Z)
	DCGQ=0.D0
	RETURN
	END
	DOUBLE PRECISION FUNCTION DAGG(Z)
	IMPLICIT REAL*8 (A-H,L-Z)
	DAGG=0.D0
	RETURN
	END
	DOUBLE PRECISION FUNCTION DBGG(Z)
	IMPLICIT REAL*8 (A-H,L-Z)
	DBGG=0.D0
	RETURN
	END
	DOUBLE PRECISION FUNCTION DCGG(Z)
	IMPLICIT REAL*8 (A-H,L-Z)
	DCGG=0.D0
	RETURN
	END
	DOUBLE PRECISION FUNCTION DAQP(Z)
	IMPLICIT REAL*8 (A-H,L-Z)
	DAQP=0.D0
	RETURN
	END
	DOUBLE PRECISION FUNCTION DBQP(Z)
	IMPLICIT REAL*8 (A-H,L-Z)
	DBQP=0.D0
	RETURN
	END
	DOUBLE PRECISION FUNCTION DCQP(Z)
	IMPLICIT REAL*8 (A-H,L-Z)
	DCQP=0.D0
	RETURN
	END
	DOUBLE PRECISION FUNCTION DAPQ(Z)
	IMPLICIT REAL*8 (A-H,L-Z)
	DAPQ=0.D0
	RETURN
	END
	DOUBLE PRECISION FUNCTION DBPQ(Z)
	IMPLICIT REAL*8 (A-H,L-Z)
	DBPQ=0.D0
	RETURN
	END
	DOUBLE PRECISION FUNCTION DCPQ(Z)
	IMPLICIT REAL*8 (A-H,L-Z)
	DCPQ=0.D0
	RETURN
	END
